> For the complete documentation index, see [llms.txt](https://docs.zama.org/protocol/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zama.org/protocol/protocol/roadmap.md).

# Roadmap

This document gives a preview of the upcoming features of FHEVM. In addition to what's listed here, you can [submit your feature request](https://github.com/zama-ai/fhevm/issues/new) on GitHub.

## Features

| Name             | Description                                               | ETA         |
| ---------------- | --------------------------------------------------------- | ----------- |
| Foundry template | [Forge](https://book.getfoundry.sh/reference/forge/forge) | Coming soon |

## Operations

| Name                  | Function name     | Type               | ETA         |
| --------------------- | ----------------- | ------------------ | ----------- |
| Signed Integers       | `eintX`           |                    | Coming soon |
| Add w/ overflow check | `FHE.safeAdd`     | Binary, Decryption | Coming soon |
| Sub w/ overflow check | `FHE.safeSub`     | Binary, Decryption | Coming soon |
| Mul w/ overflow check | `FHE.safeMul`     | Binary, Decryption | Coming soon |
| Random signed int     | `FHE.randEintX()` | Random             | -           |
| Div                   | `FHE.div`         | Binary             | -           |
| Rem                   | `FHE.rem`         | Binary             | -           |
| Set inclusion         | `FHE.isIn()`      | Binary             | -           |

{% hint style="info" %}
Random encrypted integers that are generated fully on-chain. Currently, implemented as a mockup by using a PRNG in the plain. Not for use in production!
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zama.org/protocol/protocol/roadmap.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
